Subject: bug#61302: 29.0.60; rust-ts-mode does not show function-invocation on field-properties

From: Dmitry Gutov <[email-masked]>
Date: Thu, 9 Feb 2023 23:19:08 +0200

On 09/02/2023 05:38, Randy Taylor wrote:

>> What if it looked like this:
>>
>>    let date = DateTime::<chrono::utc>::from_utc(date, chrono::utc);
>>
>> If we decide purely based on capitalization, then I guess the rule
>> should be present in both lists (with capitalized? regexp in one, and
>> !capitalized? regexp in another), and a few more rules should be
>> duplicated as well.
> 
> In both cases, utc is still a type even if it's not capitalized.
> My patch addresses this.

So the end of a scoping chain must also be either a type or a method 
call? We might be able to use that, somehow.

Though the 'use' declarations might be exceptions, e.g.

   use crate::foo::baz::foobaz;crate

or

   use std::{fmt, fs, usize};

(fmt and fs are modules, not types).

>> This becomes a little more painful semantically, given that the first
>> 'utc' in the example above is parsed into a (type_identifier) node, not
>> just (identifier).
>>
>>>> On a distantly related note, we have terms like 'usize' which is
>>>> normally a type (and highlighted as such), but can also feature in
>>>> expressions like
>>>>
>>>>     let row = usize::from_str_radix(row, 10).map_err(|_| error())?;
>>>>
>>>> where it is now highlighted with font-lock-constant-face. Should we try
>>>> to do anything about that? If there is a limited number of built-in
>>>> types in that situation (e.g. all of them primitives), we could handle
>>>> that with a regexp.
>>>
>>> Right. I think it makes sense to handle the primitives with a regex.
>>> I'm not sure if there's anything else beyond those.
>>> There's a list of them here: https://doc.rust-lang.org/reference/types.html
>>> I think it would only apply to the numerical and textual types.
>>
>> So 'usize' in the above is definitely a "type", not a "module"?
> 
> I think so. You can see on usize's documentation page (https://doc.rust-lang.org/std/primitive.usize.html)
> that it provides that function, amongst many others.

I was thinking that it might also be referring to (apparently 
deprecated) https://doc.rust-lang.org/std/usize/index.html.

Sorry, I'm not really familiar with Rust. E.g. in Ruby every class can 
also serve as a "module" in the scoping sense. As a result we highlight 
both classes and modules with font-lock-type-face. This could also be an 
option here, if everything else fails.

But we could also highlight based on a "role" (constant if it's used as 
a scope, and type if it's used as a type).

Although one could say that 'Path' in

   Some(Path::new("./foo"))

is being used as a type as well, and 'Some' too. So it might not be the 
best fit.

Speaking of 'usize' again, what if some lib or the app defines an 
'usize' module for its custom functions acting on it? E.g. 
'my::app::usize'. A simple regexp matcher will probably highlight it as 
a type as well.

>>>> Or vice versa, in
>>>>
>>>>     use std::{fmt, fs, usize};
>>>>
>>>> should 'fmt', 'fs' and 'usize' be highlighted with
>>>> font-lock-constant-face rather than font-lock-type-face?
>>>
>>> They should indeed be highlighted with font-lock-constant-face because they are modules.
>>> We assume the types will be capitalized since that's all we can really do (and it's the convention anyway).
>>
>> If they're modules here, I suppose they should be highlighted the same in
>>
>>    let row = usize::from_str_radix(...)
>>
>> as well. The bright side is that will make a more complex regexp
>> (enumerating the lowercase named types) unnecessary.
> 
> Yes, except for the primitives.
> 
> I have attached a patch which I think addresses most of the concerns (although I've been at it for a few hours and my brain is mush now).
> 
> The patch does the following:
> - Separates import-related stuff and module use by leveraging the use_declaration query (simplifying things greatly IMO).
> - Highlights primitive types used in scoped_identifiers.
> - Properly highlights types belonging to a module no matter how deep it is (or your money back guaranteed!).
> - Maybe some other stuff I forgot. I'm too tried now :).

Thank you, I can sympathize -- this stuff gets complicated.

Some problems from my testing:

1. If I keep treesit-font-lock-level at its default value (3), some 
stuff gets misfontified:

   use std::collections::hash_map::{self, HashMap};

'hash_map' is highlighted as a type. 'HashMap' is not highlighted at all.

   use std::{fmt, fs, usize};

Only 'use' is highlighted here.

   test::test1();

'test1' is highlighted as a type (we discussed this problem with 
highlighting types by default -- it becomes necessary to filter out 
function calls, either with more complex queries, or with custom 
highlighter functions).

2. If I switch to treesit-font-lock-level 4:

   let boxed_i32 = Box::new(5_i32);

'Box' is highlighted with font-lock-constant-face. I think it's a type, 
though.

Also here's a pre-existing problem mentioned above:

   use std::{fmt, fs, usize};

'fmt' and 'fs' are not types. But they are highlighted with 
font-lock-type-face.

> A few questions:
> - Should module be moved to level 3 to be with type?
> - Do we still want the module feature, or should this stuff be put into type?

I suppose we should iron some kinds out first to get a better understanding.

But if it's all the same code complexity wise, it wouldn't be the worst 
idea to keep 'module' on level 4, so level 3's highlighting is still 
somewhat subdued.